@echo off
cls
setlocal
set FW=
for  %%f in (*.sysupgrade) do set FW=%%~nxf
if "%FW%" EQU "" GOTO NOFIRMWARE 
GOTO NEXT
:NOFIRMWARE
echo No firmware file was found. Please copy a .sysupgrade firmware file to this folder.
Pause 
GOTO ERROR_EXIT

:NEXT
echo Firmware file: %FW%
echo .
set URL_OR_IP=192.168.0.100
set USERNAME=admin
set PASSWD=1234

echo Please provide the following config info (no extra spaces!)
SET /p URL_OR_IP=Enter IP address of the controller (default:%URL_OR_IP%)?:
SET /p USERNAME=Enter User Name (default:%USERNAME%)?:
SET /p PASSWD=Enter Password (default:%PASSWD%)?:

ping -n 1 %URL_OR_IP% | findstr /r /c:"[0-9] *ms"

@if "%ERRORLEVEL%"=="0" goto ENABLE_SSH

echo .
echo There doesn't seem to be anything at that IP address
pause
 
GOTO ERROR_EXIT

:ENABLE_SSH
@echo .
@echo off
@echo Enabling SSH
SET resp="ok"
FOR /F "tokens=* USEBACKQ" %%F IN (`curl -u %USERNAME%:%PASSWD% -X PUT -H "X-CSRF: x" --data "value=true" --digest "http://%URL_OR_IP%/restapi/config/ssh_enabled/"`) DO (
SET resp=%%F
)

:: Get rid of any quotes
set resp=%resp:"=%
:: Get rid of any comma
set resp=%resp:,=%
:: Get rid of any spaces
set resp=%resp: =%

IF NOT %resp% == {error:[403RESTAPIadministrativelyprohibited]} GOTO AUTH
echo .
echo Please enable the REST API from the "External APIs" page and try again (Allow REST-style API:)
pause
GOTO ERROR_EXIT

:AUTH
IF NOT %resp% == {error:[401Unauthorized]} GOTO UPDATE_IT

echo .
echo Authentication error. Please verify user name and password and try again
pause
GOTO ERROR_EXIT

:UPDATE_IT
@echo .
@echo Allowing a few seconds for the changes to take place
timeout 10
@echo .
@echo Disabling the upgrade beep (you're welcome)
curl -u %USERNAME%:%PASSWD% -X PUT -H "X-CSRF: x" --data "value=false" --digest "http://%URL_OR_IP%/restapi/config/upgrade_notify_beep/"
timeout 4
@echo .
@echo Uploading firmware
plink -P 22 -ssh -pw %PASSWD% %USERNAME%@%URL_OR_IP% "ls ./" < y.txt
pscp  -P 22 -batch -pw %PASSWD% -scp -batch %FW% %USERNAME%@%URL_OR_IP%:/tmp/ 
@echo .
@echo Starting firmware update
@echo .
plink -P 22 -ssh -pw %PASSWD% %USERNAME%@%URL_OR_IP% "sysupgrade /tmp/%FW%" < enter.txt

@echo .
@echo *** The message: "FATAL ERROR: Remote side unexpectedly closed..." is expected!
@timeout 140 /nobreak
@echo .

SET /A I=0
:AGAIN
@SET /A I+=1
@echo "Loop %i%"
ping -n 1 %URL_OR_IP% | findstr /r /c:"[0-9] *ms"
@if "%ERRORLEVEL%"=="0" goto COMPLETE
@timeout 5 /nobreak
@GOTO AGAIN

@timeout 10 /nobreak

:COMPLETE
@echo .
@echo .
@echo Firmware Update is COMPLETE!
Pause 
GOTO DONE

:ERROR_EXIT
Echo AN ERROR OCCURRED

:DONE
endlocal
